﻿Type=Class
Version=2.5
@EndOfDesignText@
'Horizontal Drawer with SnapToPosition ScrollView Class module
'Based on Klaus demo code
'Created by Cableguy 3/2/2013

Sub Class_Globals
	Private HSCDrawer As HorizontalScrollView 'Horizontal ScrollView wich will hold the ImageButtons
	Private BtnSize As Int ' Size of the ImageButtons (Squares)
	Private BtnMargin As Int ' Size of the margin between ImageButtons
	Private NButtons  As Int 'Number of ImageButtons
	Private Base As Panel 'Panel to hold the ScrollView with a 9 patch background
	Private NinePatchImage As String
	Private NVisibleBtn As Int
	Private ScrollPosMax As Int 
	Private	y0 As Int 
	Private t0 As Long
	Private speed As Double
	Private ScrollTimer As Timer
	Private DrawerTimer As Timer
	Private SlideOut As Animation
	Private SlideIn As Animation
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(Activity As Activity)
	'Initializations
	ScrollTimer.Initialize("ScrollTimer", 200)
	DrawerTimer.Initialize("DrawerTimer", 1500)
	Base.Initialize("Base")
	HSCDrawer.Initialize(500%x, "HSCDrawer")
	NButtons = 5
	BtnSize = 19.5%x
	BtnMargin = 3.75%x
	'-------------------------------------------
	'Images() Bitmap Array
	NinePatchImage = "slider" 'See the NinePatch Tutorial for more details 
	Dim Images(NButtons) As Bitmap 'Array to hold the ImageButtons Bitmaps
	Images(0).Initialize(File.DirAssets, "1-0.png")
	Images(1).Initialize(File.DirAssets, "2-0.png")
	Images(2).Initialize(File.DirAssets, "3-0.png")
	Images(3).Initialize(File.DirAssets, "4-0.png")
	Images(4).Initialize(File.DirAssets, "4-0.png")
	'----------------------------------------------------------------------
	
	'Base Layout
	Activity.AddView(Base, 1dip, 0, Activity.Width - 2dip, BtnSize + 5%x)
	Base.Top = 0-(Base.Height - 4%x)
	'---------------------------------------------------------
	'ScrollView Layout
	Base.AddView(HSCDrawer, 0, 0, 0, 0)
	HSCDrawer.Left = 3.45%x
	HSCDrawer.Width = Base.Width - 6.90%x
	HSCDrawer.Top = 1%x
	HSCDrawer.Height = BtnSize
	HSCDrawer.Panel.Width = (BtnMargin + BtnSize) * NButtons
	'---------------------------------------------------------
	'Set Base 9Patch BackGround Image
	Dim r As Reflector
	Dim package As String
	Dim id As Int
	package = r.GetStaticField("anywheresoftware.b4a.BA", "packageName")
	id = r.GetStaticField(package & ".R$drawable", NinePatchImage)
	r.Target = r.GetContext
	r.Target = r.RunMethod("getResources")
	Base.Background = r.RunMethod2("getDrawable", id, "java.lang.int")
	'----------------------------------------------------------------------
	'Add The Buttons
	Dim i As Int
	For i = 0 To NButtons - 1
		Dim btn As Button
		btn.Initialize("btnMenu")
		btn.Tag = i
		btn.SetBackgroundImage(Images(i))
		HSCDrawer.Panel.AddView(btn, (BtnMargin + BtnSize) * i, 0, BtnSize, BtnSize)
	Next

	r.Target = HSCDrawer
	r.SetOnTouchListener("HSCDrawer_Touch")
	r.RunMethod2("setHorizontalScrollBarEnabled", False, "java.lang.boolean")

	'Animation
	SlideIn.InitializeTranslate("SlideIn",0dip,0dip,0dip,0-(Base.Height - 4%x))
	SlideOut.InitializeTranslate("SlideOut",0dip,0dip,0dip,(Base.Height - 4%x))
	SlideOut.Duration = 350
	SlideIn.Duration = 350
End Sub

Sub HSCDrawer_Touch(ViewTag As Object, Action As Int, X As Float, Y As Float, MotionEvent As Object) As Boolean
	DrawerTimer.Enabled = False
	Dim dt As Long
	Dim tt As Int
	
	Select Action
	Case 0	' ACTION_DOWN
		t0 = DateTime.Now
		y0 = Y
	Case 1	' ACTION_UP
		tt = Max(10, -Logarithm(1 / speed, cE) * 50)
'		tt = Max(10, -Logarithm(1 / speed, cE) * 200)
		ScrollTimer.Interval = tt
		ScrollTimer.Enabled = True
	Case 2	' ACTION_MOVE
		dt = (DateTime.Now - t0)
		speed = Abs((Y - y0) / dt * 150)
'		speed = Abs((Y - y0) / dt * 350)
		y0 = Y
		t0 = DateTime.Now
	End Select
	
	Return False
End Sub

Private Sub ScrollTimer_Tick
	ScrollTimer.Enabled = False
	Dim Snap As Double 
	Snap = HSCDrawer.ScrollPosition/(BtnMargin + BtnSize)
	Snap = Round2(Snap,0)
	HSCDrawer.ScrollPosition = Snap * (BtnMargin + BtnSize)
	DrawerTimer.Enabled = True
End Sub

Sub btnMenu_Click
	Dim btn As Button
	btn = Sender
	CallSub2(Main,"DrawerClick", btn.Tag)
	DrawerTimer_Tick
End Sub

Private Sub Base_Click
	SlideOut.Start(Base)
	Base.Enabled = False
End Sub

Private Sub SlideOut_AnimationEnd
	DrawerTimer.Enabled = True
	Base.Top = 0
End Sub

Private Sub DrawerTimer_Tick
	DrawerTimer.Enabled = False
	SlideIn.Start(Base)
End Sub

Private Sub SlideIn_AnimationEnd
	Base.Enabled=True
	Base.Top = 0-(Base.Height - 4%x)
End Sub